<?php
/*
Plugin Name: Psli-BingMaps
Author: psli 
*/

// Chech whether we are indeed included by Piwigo.
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

// Get configuration
global $conf;
$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_KEY.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$conf[PSLI_CONF_KEY] = $row['value'];

$conf['psli_already_done'] = false;

		
// Hook to category description event
add_event_handler('render_category_description', 'PSLIBINGMAPS_Process_Album');

/********************************************************************************************/
// Process data when album is shown
/********************************************************************************************/
function PSLIBINGMAPS_Process_Album($desc) {
	global $conf, $page;
	
	// ie6 ? end here
	if (! (strpos($_SERVER['HTTP_USER_AGENT'],"MSIE 6.0") === FALSE))
		return $desc;
	
	if (isset($page['category']['id']))
	{
		$query = '
			SELECT id, lat, lon, zoom
				FROM '.PSLI_MAPS_TABLE.'
				WHERE id_category = '.$page['category']['id'].';';
		$result = pwg_query($query);
	}
		
	// First test album to control availabilty of the map
	if ((isset($page['category']['id'])) and  (pwg_db_num_rows($result) > 0) and ($conf['psli_already_done'] == false))
	{	
		// Set data for this map
		$row = pwg_db_fetch_assoc($result);
		$lon_initiale = $row['lon'];
		$zoom_initiale = $row['zoom'];
		$lat_initiale = $row['lat'];
		$id_initiale = $row['id'];
		
		// Language data
		load_language('plugin.lang', PSLI_BINGMAPS_TEMPLATE_PATH);
		
		$conf['psli_already_done'] = true;
		$desc .= "\n".'
<!-- PSLI Bing Maps Start -->		
<style type="text/css">.thumbnailCategories { display:none; }</style>
<div id=\'Coordonates\' style="color: #ffff80; font-size:120%; font-weight:bold; position:relative; margin-top:30px; width:100%; height:30px;">
</div>
<div id=\'myMap\' style="position:relative; text-align:center; height:600px; margin-bottom:15px; margin-right:15px; margin-left:15px; border:2px solid white">
</div>
<script charset="UTF-8" type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0"></script>			   
<script charset="UTF-8" type="text/javascript" src="'.PSLI_BINGMAPS_JS.'"></script>			   
<script>
psli_g_BingKey = "'.$conf[PSLI_CONF_KEY].'";
psli_g_zoomInitial = '.$zoom_initiale.';
psli_g_MapCenter = new Microsoft.Maps.Location('.$lat_initiale.', '.$lon_initiale.')'."\n";

	
		$query_entities = '
			SELECT e.id id, lat, lon, zoomMin, zoomMax, action, id_action, title, type
			  FROM '.PSLI_ENTITIES_TABLE.' e left join '.PSLI_ENTITIES_MAPS_TABLE.' j ON e.id = j.id_entity
			  WHERE j.id_map = '.$id_initiale.';';
		$result_entities = pwg_query($query_entities);
		
		// Is there any entities ?
		if (pwg_db_num_rows($result_entities) > 0)
		{			
			$desc_data = "";
			$desc_function_mouse_over = "";
			$desc_function_click = "";
		
			// For each sub category
			while ($entity = pwg_db_fetch_assoc($result_entities))
			{	
				if ($entity['id_action'] != 0)
				{	
					if ($entity['type'] == 2)
					{
						$query_datapoint = '
							SELECT lat, lon
								FROM '.PSLI_DATAPOINT_TABLE.'
								WHERE id_entity = '.$entity['id'].' ORDER BY id;';
						$result_datapoint = pwg_query($query_datapoint);
						if (pwg_db_num_rows($result_datapoint) > 0)
						{
							$desc_data .= 'var psli_t_Vertices'.$entity['id'].' = new Array();'."\n";
							while ($row = pwg_db_fetch_assoc($result_datapoint))
							{
								$desc_data .= 'psli_t_Vertices'.$entity['id'].'.push(new Microsoft.Maps.Location('.$row['lat'].','.$row['lon'].'));'."\n";
							}
							$desc_data .= '
var psli_t_Child'.$entity['id'].' = new Microsoft.Maps.Polygon(psli_t_Vertices'.$entity['id'].',{fillColor: psli_g_PolygonColor, strokeColor: psli_g_PolygonColor});'."\n";

							$desc_function_mouse_over .= '
function psli_MapsMouseOver_'.$entity['id'].' (e) { 
  document.getElementById("Coordonates").innerHTML = "'.l10n('Click to zoom on')." ".$entity['title'].'";
}'."\n";
						}
					}
					else
					{
						$desc_data .= '
var psli_t_Child'.$entity['id'].' = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location('.$entity['lat'].','.$entity['lon'].'));'."\n";

						$desc_function_mouse_over .= '
function psli_MapsMouseOver_'.$entity['id'].' (e) { 
  document.getElementById("Coordonates").innerHTML = "'.l10n('Click to show pictures of')." ".$entity['title'].'";
}'."\n";
					}
					
					$desc_data .= '
Microsoft.Maps.Events.addHandler(psli_t_Child'.$entity['id'].', "mouseover", psli_MapsMouseOver_'.$entity['id'].');
Microsoft.Maps.Events.addHandler(psli_t_Child'.$entity['id'].', "mouseout", psli_MapsMouseOut);
Microsoft.Maps.Events.addHandler(psli_t_Child'.$entity['id'].', "click", psli_MapsClick_'.$entity['id'].');'."\n";
		
					switch ($entity['action'])
					{
						case 1:	
							$desc_function_click .= '
function psli_MapsClick_'.$entity['id'].' (e) { 
	psli_g_Map.setView({zoom:'.$entity['id_action'].', center: new Microsoft.Maps.Location('.$entity['lat'].', '.$entity['lon'].')});
}'."\n";
							break;
						case 2:
							$desc_function_click .= '
function psli_MapsClick_'.$entity['id'].' (e) { 
	document.location.href=\'index.php?/category/'.$entity['id_action'].'\';
}'."\n";
							break;
						case 3:
							$desc_function_click .= '
function psli_MapsClick_'.$entity['id'].' (e) { 
  document.location.href=\'picture.php?/'.$entity['id_action'].'\';
}'."\n";
							break;				
					}
				
					for ($i = $entity['zoomMin']; $i <= $entity['zoomMax']; $i++)
					{
						$desc_data .= 'psli_g_ZoomEntity['.($i - 1).'].push(psli_t_Child'.$entity['id'].');'."\n";
					}
				}
			}
			$desc .= $desc_data;
			$desc .= $desc_function_mouse_over;
			$desc .= $desc_function_click;
		}
		$desc .= '
psli_InitGuestMap();
</script>'."\n";	   	
	}
	return $desc;
}
?>