<?php
/*
Plugin Name: Psli-BingMaps
Author: psli 
*/

$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_VERSION_MAJ.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$version_maj = $row['value'];

$query = '
	SELECT value
		FROM '.CONFIG_TABLE.'
		WHERE param = "'.PSLI_CONF_VERSION_MIN.'";';
$result = pwg_query($query);
$row = pwg_db_fetch_assoc($result);
$version_min = $row['value'];

// from version 1.0
if (($version_maj == "1") and ($version_min == "0"))
{
	// No differences between 1.0 and 1.1 except localization
	// Just update version in configuration
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MAJ . '"
			WHERE param = "'.PSLI_CONF_VERSION_MAJ.'"
			LIMIT 1';
	pwg_query($query);
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MIN . '"
			WHERE param = "'.PSLI_CONF_VERSION_MIN.'"
			LIMIT 1';
	pwg_query($query);
	$version_maj = "1";
	$version_min = "1";
}

// from version 1.1
if (($version_maj == "1") and ($version_min == "1"))
{
	// No differences between 1.1 and 1.2 except localization
	// Just update version in configuration
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MAJ . '"
			WHERE param = "'.PSLI_CONF_VERSION_MAJ.'"
			LIMIT 1';
	pwg_query($query);
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MIN . '"
			WHERE param = "'.PSLI_CONF_VERSION_MIN.'"
			LIMIT 1';
	pwg_query($query);
	$version_maj = "1";
	$version_min = "2";
}

// from version 1.2
if (($version_maj == "1") and ($version_min == "2"))
{
	// New Conf data in v1.3
	// Update version and create new conf param PSLI_CONF_PATH
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MAJ . '"
			WHERE param = "'.PSLI_CONF_VERSION_MAJ.'"
			LIMIT 1';
	pwg_query($query);
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MIN . '"
			WHERE param = "'.PSLI_CONF_VERSION_MIN.'"
			LIMIT 1';
	pwg_query($query);
	$version_maj = "1";
	$version_min = "3";
	$sql = 'INSERT INTO '.CONFIG_TABLE." (param, value) VALUES ('".PSLI_CONF_PATH."', 'http://".$_SERVER['HTTP_HOST'].substr($_SERVER['REQUEST_URI'],0, strrpos($_SERVER['REQUEST_URI'],"/"))."/');";	
    pwg_query($sql);
}

// from version 1.3
if (($version_maj == "1") and ($version_min == "3"))
{
	// New table MAPS and changes in Entities table
	define('PSLI_CONF_LAT', 'PsliBingMapsLat');
	define('PSLI_CONF_LON', 'PsliBingMapsLon');
	define('PSLI_CONF_ZOOM', 'PsliBingMapsZoom');
	define('PSLI_CONF_CATEGORY', 'PsliBingMapsCategoryInitiale');
	
	// Create table Maps and default element
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.PSLI_MAPS_TABLE."` (
			`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`id_category` smallint(5) unsigned DEFAULT NULL,
			`title` text,
			`lat` decimal(15,12) DEFAULT '0.000000000000',
			`lon` decimal(15,12) DEFAULT '0.000000000000',
			`zoom` smallint(6) DEFAULT NULL,
			PRIMARY KEY (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	pwg_query($sql);
	
	// Create table Entity-Map and default element
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.PSLI_ENTITIES_MAPS_TABLE."` (
			`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`id_entity` smallint(5) unsigned DEFAULT NULL,
			`id_map` smallint(5) unsigned DEFAULT NULL,
			PRIMARY KEY (`id`),
			UNIQUE `psli_entity_map_1` (`id_entity`, `id_map`),
			INDEX `psli_entity_map_2` (`id_entity`),
			INDEX `psli_entity_map_3` (`id_map`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	pwg_query($sql);
	
	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_LAT.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	$lat = $row['value'];

	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_LON.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	$lon = $row['value'];

	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_ZOOM.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	$zoom = $row['value'];
	
	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_CATEGORY.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	$category = $row['value'];
	if ($category == 'to define')
	{
		$category = 'null';
	}

	$sql = "INSERT INTO `".PSLI_MAPS_TABLE."` (`id`, `id_category`, `title`, `lat`, `lon`, `zoom`) 
				VALUES (1, ".$category.", 'Default', ".$lat.", ".$lon.", ".$zoom.");";	
    pwg_query($sql);	
	
	$sql = "INSERT INTO `".PSLI_ENTITIES_MAPS_TABLE."` (`id_entity`, `id_map`) 
				SELECT id, 1 FROM `".PSLI_ENTITIES_TABLE."`;";	
    pwg_query($sql);
	
	// Update table Entities
	$sql = 'ALTER TABLE `'.PSLI_ENTITIES_TABLE.'` DROP INDEX `psli_i10`;';	
    pwg_query($sql);	
	$sql = 'ALTER TABLE `'.PSLI_ENTITIES_TABLE.'` CHANGE COLUMN `id_category` `id_action` smallint(5) unsigned DEFAULT NULL;';	
    pwg_query($sql);
	$sql = 'ALTER TABLE `'.PSLI_ENTITIES_TABLE.'` ADD COLUMN `type` smallint(1) default 1;';	
    pwg_query($sql); 
	$sql = 'UPDATE `'.PSLI_ENTITIES_TABLE.'` SET `id_action`=`action`, `action`=1 WHERE `action` <> 0;';	
    pwg_query($sql);
	$sql = 'UPDATE `'.PSLI_ENTITIES_TABLE.'` SET `action`=2 WHERE `action` = 0;';	
    pwg_query($sql);
	$sql = 'UPDATE '.PSLI_ENTITIES_TABLE.' e SET e.type=2 where exists (select * from '.PSLI_DATAPOINT_TABLE.' d where d.id_entity = e.id);';	
    pwg_query($sql);
		
	// Drop conf param PSLI_CONF_LAT, PSLI_CONF_LON, PSLI_CONF_ZOOM	
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_LAT."';";
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_LON."';";
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_ZOOM."';";
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_CATEGORY."';";
	pwg_query($sql);
	
	// Update version
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MAJ . '"
			WHERE param = "'.PSLI_CONF_VERSION_MAJ.'"
			LIMIT 1';
	pwg_query($query);
	$query = '
		UPDATE '.CONFIG_TABLE.'
			SET value = "' . PSLI_VERSION_MIN . '"
			WHERE param = "'.PSLI_CONF_VERSION_MIN.'"
			LIMIT 1';
	pwg_query($query);
	$version_maj = "2";
	$version_min = "0";
}

?>