<?php
/*
Version: 1.2
Plugin Name: Psli-BingMaps
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=603
Author: psli 
Description: Extension to piwigo for use of bing maps to navigate in geolocalized album
*/
// Chech whether we are indeed included by Piwigo.
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

// define generic Path
define ('PSLI_BINGMAPS_PATH', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');
define('PSLI_BINGMAPS_TEMPLATE_PATH', dirname(__FILE__).'/');
define ('PSLI_BINGMAPS_VERSION_INC_PHP', PSLI_BINGMAPS_PATH.'include/version.inc.php');

// Include define data and global function
include_once(dirname(__FILE__).'/include/const.inc.php');
include_once(dirname(__FILE__).'/include/function.inc.php');

// Check plugin update
include_once(PSLI_BINGMAPS_VERSION_INC_PHP);

//******* Language data *******
load_language('plugin.lang', PSLI_BINGMAPS_TEMPLATE_PATH);

// Plugin for admin
if (script_basename() == 'admin')   
{
	// Check if site root changed 
	// define Path for JS file
	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_PATH.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	$root = 'http://'.$_SERVER['HTTP_HOST'].substr($_SERVER['REQUEST_URI'],0, strrpos($_SERVER['REQUEST_URI'],"/")).'/';
	if ($root != $row['value'])
	{
		$sql = 'UPDATE '.CONFIG_TABLE." SET value = '".$root."' WHERE param = '".PSLI_CONF_PATH."';";	
		pwg_query($sql);
	}
	else	
	{
		$root = $row['value'];
	}
	
	// define Path for admin file
	define ('PSLI_BINGMAPS_ADMIN_PHP', PSLI_BINGMAPS_PATH.'admin/admin.php');
	define ('PSLI_BINGMAPS_CLASS_ENTITY_PHP', PSLI_BINGMAPS_PATH.'admin/class/psli_entity.class.php');
	
	// Define path for configuration tab 
	define ('PSLI_BINGMAPS_ADMIN_CONF_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_conf.inc.php');
	define ('PSLI_BINGMAPS_ADMIN_CONF_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_conf.tpl');
	
	// Define path for map tab
	define ('PSLI_BINGMAPS_ADMIN_MAP_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_map.inc.php');
	define ('PSLI_BINGMAPS_CLASS_MAP_PHP', PSLI_BINGMAPS_PATH.'admin/class/psli_map.class.php');
	define ('PSLI_BINGMAPS_ADMIN_MAP_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_map.tpl');
	define ('PSLI_BINGMAPS_JS_MAP', $root.'plugins/Psli-BingMaps/admin/JS/Psli-BingMaps-Map.js');
	
	// Define path for pin tab
	define ('PSLI_BINGMAPS_ADMIN_PIN_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_pin.inc.php');
	define ('PSLI_BINGMAPS_CLASS_PIN_PHP', PSLI_BINGMAPS_PATH.'admin/class/psli_pin.class.php');
	define ('PSLI_BINGMAPS_ADMIN_PIN_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_pin.tpl');
	define ('PSLI_BINGMAPS_JS_PIN', $root.'plugins/Psli-BingMaps/admin/JS/Psli-BingMaps-Pin.js');
	
	// Define path for zone tab
	define ('PSLI_BINGMAPS_ADMIN_ZONE_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_zone.inc.php');
	define ('PSLI_BINGMAPS_CLASS_ZONE_PHP', PSLI_BINGMAPS_PATH.'admin/class/psli_zone.class.php');
	define ('PSLI_BINGMAPS_ADMIN_ZONE_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_zone.tpl');
	define ('PSLI_BINGMAPS_JS_ZONE', $root.'plugins/Psli-BingMaps/admin/JS/Psli-BingMaps-Zone.js');
	
	// Define path for picture tab
	define ('PSLI_BINGMAPS_ADMIN_PICTURE_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_picture.inc.php');
	define ('PSLI_BINGMAPS_CLASS_PICTURE_PHP', PSLI_BINGMAPS_PATH.'admin/class/psli_picture.class.php');
	define ('PSLI_BINGMAPS_ADMIN_PICTURE_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_picture.tpl');
	
	// Define path for exif tab
	define ('PSLI_BINGMAPS_ADMIN_EXIF_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_exif.inc.php');
	define ('PSLI_BINGMAPS_ADMIN_EXIF_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_exif.tpl');
	
	// Define path for batch tab
	define ('PSLI_BINGMAPS_ADMIN_BATCH_PHP', PSLI_BINGMAPS_PATH.'admin/include/admin_batch.inc.php');
	define ('PSLI_BINGMAPS_ADMIN_BATCH_TPL', PSLI_BINGMAPS_TEMPLATE_PATH.'admin/template/admin_batch.tpl');
	define ('PSLI_BINGMAPS_ADMIN_BATCH_CSS', PSLI_BINGMAPS_PATH.'admin/css/admin_batch.css');
	
	
	// Hook on to event on administration page.
	add_event_handler('get_admin_plugin_menu_links', 'PSLIBINGMAPS_admin_menu');
}
else
{
	// define Path for JS file
	$query = '
		SELECT value
			FROM '.CONFIG_TABLE.'
			WHERE param = "'.PSLI_CONF_PATH.'";';
	$result = pwg_query($query);
	$row = pwg_db_fetch_assoc($result);
	
	define ('PSLI_BINGMAPS_GUEST_INC_PHP', PSLI_BINGMAPS_PATH.'include/guest.inc.php');
	define ('PSLI_BINGMAPS_JS', $row['value'].'plugins/Psli-BingMaps/JS/Psli-BingMaps.js');
	
	include_once(PSLI_BINGMAPS_GUEST_INC_PHP);
}

/********************************************************************************************/
// Add an entry to the 'Plugins' menu.
/********************************************************************************************/
function PSLIBINGMAPS_admin_menu($menu) {
 array_push(
   $menu,
   array(
     'NAME'  => 'PSLI-BingMaps',
     'URL'   => get_admin_plugin_menu_link(PSLI_BINGMAPS_ADMIN_PHP)
   )
 );
 return $menu;
}

?>