<?php
/*
Plugin Name: Psli-BingMaps
Author: psli 
*/

// Chech whether we are indeed included by Piwigo.
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

// Include define data
include_once(dirname(__FILE__).'/include/const.inc.php');

/********************************************************************************************/
//               Plugin installation
// Create all needed tables and parameters ( with value by default) in CONFIG_TABLE
/********************************************************************************************/
function plugin_install($plugin_id, $plugin_version, &$errors)
{
	global $prefixeTable;
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.PSLI_MAPS_TABLE."` (
			`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`id_category` smallint(5) unsigned DEFAULT NULL,
			`title` text,
			`lat` decimal(15,12) DEFAULT '0.000000000000',
			`lon` decimal(15,12) DEFAULT '0.000000000000',
			`zoom` smallint(6) DEFAULT NULL,
			PRIMARY KEY (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	pwg_query($sql);
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.PSLI_ENTITIES_TABLE."` (
			`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`lat` decimal(15,12) DEFAULT '0.000000000000',
			`lon` decimal(15,12) DEFAULT '0.000000000000',
			`title` text,
			`zoomMin` smallint(6) DEFAULT NULL,
			`zoomMax` smallint(6) DEFAULT NULL,
			`action` smallint(6) DEFAULT NULL,
			`id_action` smallint(5) unsigned DEFAULT NULL,
			`type` smallint(1) default 1,
			PRIMARY KEY (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	pwg_query($sql);
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.PSLI_ENTITIES_MAPS_TABLE."` (
			`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`id_entity` smallint(5) unsigned DEFAULT NULL,
			`id_map` smallint(5) unsigned DEFAULT NULL,
			PRIMARY KEY (`id`),
			UNIQUE `psli_entity_map_1` (`id_entity`, `id_map`),
			INDEX `psli_entity_map_2` (`id_entity`),
			INDEX `psli_entity_map_3` (`id_map`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
	pwg_query($sql);	
	
	$sql = '
		CREATE TABLE IF NOT EXISTS `'.PSLI_DATAPOINT_TABLE.'` (
			`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`id_entity` smallint(5) unsigned,
			`lat` decimal(20,17) DEFAULT NULL,
			`lon` decimal(20,17) DEFAULT NULL,
			PRIMARY KEY (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;';
	pwg_query($sql);
		
	$sql = 'INSERT INTO '.CONFIG_TABLE." (param, value) VALUES ('".PSLI_CONF_KEY."', 'to define');";
	pwg_query($sql);
	
	$sql = 'INSERT INTO '.CONFIG_TABLE." (param, value) VALUES ('".PSLI_CONF_VERSION_MAJ."', '".PSLI_VERSION_MAJ."');";
	pwg_query($sql);
	
	$sql = 'INSERT INTO '.CONFIG_TABLE." (param, value) VALUES ('".PSLI_CONF_VERSION_MIN."', '".PSLI_VERSION_MIN."');";
	pwg_query($sql);	
	
	$sql = 'INSERT INTO '.CONFIG_TABLE." (param, value) VALUES ('".PSLI_CONF_PATH."', 'http://".$_SERVER['HTTP_HOST'].substr($_SERVER['REQUEST_URI'],0, strrpos($_SERVER['REQUEST_URI'],"/"))."/');";	
	pwg_query($sql);
	
	array_push($page['infos'], l10n('Information data registered in database'));
}

/********************************************************************************************/
//               Plugin deactivation
// Destroy tables and parameters created by plugin
/********************************************************************************************/
function plugin_uninstall($plugin_id)
{
	global $prefixeTable;
	$sql = 'DROP TABLE `'.PSLI_MAPS_TABLE.'`;';
	pwg_query($sql);
	$sql = 'DROP TABLE `'.PSLI_ENTITIES_TABLE.'`;';
	pwg_query($sql);
	$sql = 'DROP TABLE `'.PSLI_ENTITIES_MAPS_TABLE.'`;';
	pwg_query($sql);
	$sql = 'DROP TABLE `'.PSLI_DATAPOINT_TABLE.'`;';
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_KEY."';";
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_VERSION_MAJ."';";
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_VERSION_MIN."';";
	pwg_query($sql);
	$sql = 'DELETE FROM `'.CONFIG_TABLE."` WHERE param = '".PSLI_CONF_PATH."';";
	pwg_query($sql);
	
	array_push($page['infos'], l10n('Information data registered in database'));
}

?>